<?php

class DispletRetsIdxModel{
	public function get_model(){
		global $displetretsidx_option;
		$listings_per_page = intval($displetretsidx_option['listings_per_page']);
		$model = array(
			'options' => $displetretsidx_option,
			'is_displet_api' => (!empty($displetretsidx_option['displet_app_key'])) ? true : false,
			'listings_per_page' => ($listings_per_page > 1 && $listings_per_page < 51) ? $listings_per_page : 10,
			'orientation' => $displetretsidx_option['listings_orientation'], // Exists due to previous use in custom templates
			'last_updated' => date('Y-m-d', strtotime('-12 hours'))
		);
		$model['options']['disclaimer'] = DispletRetsIdxListings::get_disclaimer($model);
		return $model;
	}

	public function globalize(){
		// To-do: replace $displetretsidx_option with $displetretsidx_model['options']
		global $displetretsidx_option;
		$displetretsidx_option = DispletRetsIdxSettings::get_option();
		$model = self::get_model();
		self::globalize_model($model);
	}

	public function globalize_model($model){
		global $displetretsidx_model;
		$displetretsidx_model = $model;
	}

	public function prep_for_listings($model){
		if (!isset($model['property_type_navigation'])) {
			$model['property_type_navigation'] = $model['options']['include_property_type_navigation'];
		}
		if (!isset($model['show_listings'])) {
			$model['show_listings'] = 'yes';
		}
		if (!isset($model['price_navigation'])) {
			$model['price_navigation'] = $model['options']['include_price_navigation'];
		}
		if (!isset($model['stats'])) {
			$model['stats'] = $model['options']['include_stats'];
		}
		if (!isset($model['layout'])) {
			$model['layout'] = $model['options']['listings_layout'];
		}
		if (!isset($model['property_type_sorting'])) {
			$model['property_type_sorting'] = $model['options']['include_property_type_sorting'];
		}
		if (!isset($model['shortcode_count'])) {
			$model['shortcode_count'] = 1;
		}
		return $model;
	}

	public function include_javascript_variables(){
		global $displetretsidx_model;
		echo DispletRetsIdxLoad::get_template('displet-javascript-variables.php', $displetretsidx_model);
	}

	public function include_admin_javascript_variables(){
		global $displetretsidx_model;
		echo DispletRetsIdxLoad::get_template('displet-admin-javascript-variables.php', $displetretsidx_model);
	}
}

add_action('after_setup_theme', array('DispletRetsIdxModel', 'globalize'));
add_action('wp_head', array('DispletRetsIdxModel', 'include_javascript_variables'));
add_action('admin_head', array('DispletRetsIdxModel', 'include_admin_javascript_variables'));

?>